"//Home script\n"
"'use strict';\n"
"\n"
"let pseudo          = new Clock();\n"
"let rtc             = new Clock();\n"
"\n"
"let pseudoDisplay   = false;\n"
"let pseudoStartMs   = 0;\n"
"\n"
"let diffMs          = 0;\n"
"\n"
"let rtcIsSet        = false;\n"
"let clockIsSet      = false;\n"
"let ppsStable       = false;\n"
"let nmeaStable      = false;\n"
"let rateIsLocked    = false;\n"
"let timeIsLocked    = false;\n"
"\n"
"const DISPLAY_LEAP_MS = 10000;\n"
"\n"
"function parse()\n"
"{\n"
"    let lines = Ajax.response.split('\\n');\n"
"    rtc.ms          = Ajax.date.getTime();\n"
"    rtc.ms         += parseInt(lines[0], 16);\n"
"    rtc.ms         -= Ajax.ms;\n"
"    diffMs          = rtc.ms + Ajax.ms - Date.now();\n"
"    rtcIsSet        = Ajax.hexToBit(lines[1], 0);\n"
"    clockIsSet      = Ajax.hexToBit(lines[1], 1);\n"
"    ppsStable       = Ajax.hexToBit(lines[1], 2);\n"
"    nmeaStable      = Ajax.hexToBit(lines[1], 3);\n"
"    rateIsLocked    = Ajax.hexToBit(lines[1], 4);\n"
"    timeIsLocked    = Ajax.hexToBit(lines[1], 5);\n"
"    rtc.leapEnable  = Ajax.hexToBit(lines[1], 6);\n"
"    rtc.leapForward = Ajax.hexToBit(lines[1], 7);\n"
"    rtc.months1970  = parseInt(lines[2], 16);\n"
"    rtc.leaps       = parseInt(lines[3], 16);\n"
"}\n"
"function display()\n"
"{\n"
"    let elem;\n"
"    elem = Ajax.getElementOrNull('ajax-rtc-set'      ); if (elem) elem.setAttribute('dir', rtcIsSet     ? 'rtl' : 'ltr');\n"
"    elem = Ajax.getElementOrNull('ajax-clock-set'    ); if (elem) elem.setAttribute('dir', clockIsSet   ? 'rtl' : 'ltr');\n"
"    elem = Ajax.getElementOrNull('ajax-pps-stable'   ); if (elem) elem.setAttribute('dir', ppsStable    ? 'rtl' : 'ltr');\n"
"    elem = Ajax.getElementOrNull('ajax-nmea-stable'  ); if (elem) elem.setAttribute('dir', nmeaStable   ? 'rtl' : 'ltr');\n"
"    elem = Ajax.getElementOrNull('ajax-rate-locked'  ); if (elem) elem.setAttribute('dir', rateIsLocked ? 'rtl' : 'ltr');\n"
"    elem = Ajax.getElementOrNull('ajax-time-locked'  ); if (elem) elem.setAttribute('dir', timeIsLocked ? 'rtl' : 'ltr');\n"
"    \n"
"    elem = Ajax.getElementOrNull('ajax-leap-enable'  ); if (elem) elem.setAttribute('dir', rtc.leapEnable   ? 'rtl' : 'ltr');\n"
"    elem = Ajax.getElementOrNull('ajax-leap-forward' ); if (elem) elem.setAttribute('dir', rtc.leapForward  ? 'rtl' : 'ltr');\n"
"    \n"
"    elem = Ajax.getElementOrNull('ajax-leap-year'    ); if (elem) elem.value = rtc.months1970 ? rtc.leapYear  : '';\n"
"    elem = Ajax.getElementOrNull('ajax-leap-month'   ); if (elem) elem.value = rtc.months1970 ? rtc.leapMonth : '';\n"
"    \n"
"    elem = Ajax.getElementOrNull('ajax-leap-count'   ); if (elem) elem.value = rtc.leaps;\n"
"    \n"
"    elem = Ajax.getElementOrNull('ajax-date-diff'    ); if (elem) elem.textContent = diffMs;\n"
"}\n"
"\n"
"function handleTick() //This typically called every 100ms\n"
"{\n"
"    if (pseudoDisplay)\n"
"    {\n"
"        pseudo.adjustLeap (Ajax.ms);\n"
"        pseudo.displayTime(Ajax.ms);\n"
"        if (Ajax.ms >= pseudoStartMs + DISPLAY_LEAP_MS + 500) pseudoDisplay = false;\n"
"    }\n"
"    else\n"
"    {\n"
"        rtc.adjustLeap (Ajax.ms);\n"
"        rtc.displayTime(Ajax.ms);\n"
"    }\n"
"}\n"
"\n"
"function displayLeap() //Called by display leap button in HTML\n"
"{\n"
"   pseudoDisplay = true;\n"
"   pseudoStartMs = Ajax.ms;\n"
"   \n"
"   pseudo.leapEnable  = true;\n"
"   pseudo.leapForward = rtc.leapForward;\n"
"   pseudo.leaps       = rtc.leaps;\n"
"   pseudo.leapMonth   = rtc.leapMonth;\n"
"   pseudo.leapYear    = rtc.leapYear;\n"
"   pseudo.ms          = Date.UTC(rtc.leapYear, rtc.leapMonth - 1, 1) - DISPLAY_LEAP_MS / 2 - Ajax.ms;\n"
"}\n"
"Ajax.server     = '/home-ajax';\n"
"Ajax.onResponse = function() { parse(); display(); };\n"
"Ajax.onTick     = handleTick;\n"
"Ajax.init();\n"
"\n"
""